0103abc
0103abc 的网站
= 算法、题解与学习记录 =
文章列表
签到题。令根节点深度为 $1$,则考虑到一个点如果深度 $>3$,那么她或者距离她 $\le 1$ 的结点就必须进行操作。因此拿个堆每一次找到当前没有被更新过且需要被更新的深度最深的点,用她的父亲暴力更新她父亲距离不超过 $1$ 的结点,时间复杂度为 $O(n\log n)$ 可以通过。
还是想介绍一下我的巨大哈希做法。 题目本身是比较简单的,就是直接分类讨论: $k=1$,此时任何串都是回文的,一定不是 good。 $k=r-l+1$,此时若整串回文,则不是 good,否则是 good。可以用三哈希处理。 $2\mid k$,此时若字符串内所有字符全都相同,则所有偶数长度均非...
$k$ 很大,因此考虑矩阵快速幂。考虑找出图 $G$ 的一个导出子图,对于每一对 $(x,y)$,若 $x,y$ 都为陷阱且有边相连,则 $x,y$ 以及连接她们的一条无向边都在这个导出子图中。 现在只需要求出图中两两不经过其他导出子图结点...
「感觉能独立想出这题的人,脑子和蛇一样聪明」 一眼看上去这题十分神秘不可做,因此考虑逐步挖掘其性质。 性质:有用的操作其实只有 $1,4$ 两种。 证明: 对于 $2$ 操作:则可以先用一次 $1$ 操作操作掉整个左侧,然后再把不包含于她的左上角操作。这样花费的代价为 $2$,优于 $1$ 次...
容易观察得出后手必胜的充要条件是 $a$ 序列存在一个子序列 $b$ 使得 $2\sum bi=\sum ai$。这个部分可以直接 $O(n^3)$ 暴力求解。 证明的话:如果可以划分出这样的一个子序列 $b$ 那么后手可以和先手对称选取,...
建议先阅读 $\textbf{Easy Ver.}$ 题解。 前情提要:我不会做这题。所以我用了一个奇奇怪怪的时间复杂度极劣的做法通过了这个题。如果要学习正解建议跳过这篇题解。如果用这个做法的话这题最多蓝( 在简单版本中,没有删除操作,因此对于同一个 $k$...
好简单一题。考虑到弱化版只有添加和查询没有删除,因此对于每一个相同的 $k$ 随时间推移答案肯定单调不降。所以直接用 维护当前所有出现过的数,然后用 暴力维护每一个 $k$ 当前的答案即可。更新的时候无需维护,只需要在查询的时候直接暴力往上跳答案即可。没有什么手法。
~~来水一篇题解~~ 十分简单的 $2400$。考虑到质数的因子数量相对较少,而且两个数 $a1,a2$ 若能表示为 $a1=p1p2,a2=p3p4$ 的形式($\forall i\in[1,4],pi\in\text{prime}$),则 $a1=a2$ 当且仅当 $\lbrace...
首先特殊判断某一行或某一列的数全部填完,且这行或这列所有数乘积不为 $-1$ 的情况,该情况无解。同样还有若 $n\not\equiv m\pmod 2$,则奇偶性分析后可知显然也无解。 先考虑一个简单一些的子问题:若 $k<\min(n,...
考虑类似于 Floyd 的 dp 设计:设 $f{o,i,j}$ 表示从 $i$ 到 $j$ 走了 $o$ 条边的不同方案数,那么显然有初始条件:对于每一条边 $u\leftrightarrow v$,都有 $f{1,u,v}=f{1,v,u}=1$。转移的话枚举中转点 $k$ 然后用...